<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX User Guide: tivx_reference_t Struct Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>tivx_reference_t Struct Reference<br/>
<small>
[<a class="el" href="group__group__vx__reference.html">Reference APIs</a>]</small>
</h1><!-- doxytag: class="tivx_reference_t" --><hr/><a name="_details"></a><h2>Detailed Description</h2>
<p>The most basic type in the OpenVX system. Any type that inherits from <a class="el" href="structtivx__reference__t.html" title="The most basic type in the OpenVX system. Any type that inherits from tivx_reference_t...">tivx_reference_t</a> must have a vx_reference_t as its first memeber to allow casting to this type. </p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Data Fields</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">uint32_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__reference__t.html#a1ddc639bc476ab1eec28de9a264f28cd">magic</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Magic code which confirms this is a reference.  <a href="#a1ddc639bc476ab1eec28de9a264f28cd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__reference__t.html#ab426d5bb07f9725e5a71a6d84e58b81c">type</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set to an enum value in <a class="el" href="vx__types_8h.html#a44aa67e15168e5912a0800090a120be6">vx_type_e</a>.  <a href="#ab426d5bb07f9725e5a71a6d84e58b81c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a0f4f894d935fbf50bf38b3529a001249">vx_context</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__reference__t.html#a2d32696383b6ba91da028b4d1ae6ff7b">context</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Pointer to the top level context. If this reference is the context, this will be NULL.  <a href="#a2d32696383b6ba91da028b4d1ae6ff7b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__reference__t.html#ac5f7c7cef208efccb8a400470d6b6611">scope</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The pointer to the object's scope parent. When virtual objects are scoped within a graph, this will point to that parent graph. This is left generic to allow future scoping variations. By default scope should be the same as context.  <a href="#ac5f7c7cef208efccb8a400470d6b6611"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">char&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__reference__t.html#a2f4a238aac75334b52e1b9a52a576194">name</a> [VX_MAX_REFERENCE_NAME]</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Reference name.  <a href="#a2f4a238aac75334b52e1b9a52a576194"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a1ddb983b9696cafdb4256c0df757171c">vx_uint32</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__reference__t.html#a642d6c4ea88ea88f63fc426a4ab33fe2">external_count</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The count of the number of users with this reference. When greater than 0, this can not be freed. When zero, the value can be considered inaccessible.  <a href="#a642d6c4ea88ea88f63fc426a4ab33fe2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a1ddb983b9696cafdb4256c0df757171c">vx_uint32</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__reference__t.html#a6f9a5f3dcba8c5228dca31493f98f742">internal_count</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The count of the number of framework references. When greater than 0, this can not be freed.  <a href="#a6f9a5f3dcba8c5228dca31493f98f742"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__group__vx__reference.html#ga8e985f6c4f883699f2b91dae32f95c8b">tivx_reference_callback_f</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__reference__t.html#a8aa4044294f8eb1c30ce4d09afd1c4fa">mem_alloc_callback</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Object specific function that is called to allcoate object memory.  <a href="#a8aa4044294f8eb1c30ce4d09afd1c4fa"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__group__vx__reference.html#ga8e985f6c4f883699f2b91dae32f95c8b">tivx_reference_callback_f</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__reference__t.html#a9263b6aa76840e5254d766e9567af7dd">destructor_callback</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Object specific function that is called to destroy an object when refernce count reaches zero.  <a href="#a9263b6aa76840e5254d766e9567af7dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">tivx_reference_release_callback_f&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__reference__t.html#a68918255893d2784a3aa9ac6ad638edf">release_callback</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Object specific function that is called to release an object.  <a href="#a68918255893d2784a3aa9ac6ad638edf"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__group__tivx__mutex.html#gaca8bf54b8519ecd4c6aa8368286bde45">tivx_mutex</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__reference__t.html#a743a14f09405c30f5f39e36bde0beaef">lock</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Lock to take for the reference.  <a href="#a743a14f09405c30f5f39e36bde0beaef"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a2c6de63476aff4a009bac8d0eb9800d1">vx_delay</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__reference__t.html#af655518f6f2a7e179d828e95c1a74ce8">delay</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a822fc495cb9045d45893eed297d48737">vx_int32</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__reference__t.html#a1caf1c5feb88111ebb5e38a4da188bd9">delay_slot_index</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0">vx_bool</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__reference__t.html#ae599ad74e0f2733829ae0e99c666a1fc">is_virtual</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This indicates if the object is virtual or not.  <a href="#ae599ad74e0f2733829ae0e99c666a1fc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0">vx_bool</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__reference__t.html#afcce2c06f3667f29ef1688dbd8542f05">is_accessible</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Can this reference be accessed by user application Used for virtual reference's only.  <a href="#afcce2c06f3667f29ef1688dbd8542f05"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structtivx__obj__desc__t.html">tivx_obj_desc_t</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__reference__t.html#a1f5d87219e4c59beee89ad61376ef464">obj_desc</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">object descriptor  <a href="#a1f5d87219e4c59beee89ad61376ef464"></a><br/></td></tr>
</table>
<hr/><h2>Field Documentation</h2>
<a class="anchor" id="a1ddc639bc476ab1eec28de9a264f28cd"></a><!-- doxytag: member="tivx_reference_t::magic" ref="a1ddc639bc476ab1eec28de9a264f28cd" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t <a class="el" href="structtivx__reference__t.html#a1ddc639bc476ab1eec28de9a264f28cd">tivx_reference_t::magic</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Magic code which confirms this is a reference. </p>

</div>
</div>
<a class="anchor" id="ab426d5bb07f9725e5a71a6d84e58b81c"></a><!-- doxytag: member="tivx_reference_t::type" ref="ab426d5bb07f9725e5a71a6d84e58b81c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> <a class="el" href="structtivx__reference__t.html#ab426d5bb07f9725e5a71a6d84e58b81c">tivx_reference_t::type</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set to an enum value in <a class="el" href="vx__types_8h.html#a44aa67e15168e5912a0800090a120be6">vx_type_e</a>. </p>

</div>
</div>
<a class="anchor" id="a2d32696383b6ba91da028b4d1ae6ff7b"></a><!-- doxytag: member="tivx_reference_t::context" ref="a2d32696383b6ba91da028b4d1ae6ff7b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a0f4f894d935fbf50bf38b3529a001249">vx_context</a> <a class="el" href="structtivx__reference__t.html#a2d32696383b6ba91da028b4d1ae6ff7b">tivx_reference_t::context</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Pointer to the top level context. If this reference is the context, this will be NULL. </p>

</div>
</div>
<a class="anchor" id="ac5f7c7cef208efccb8a400470d6b6611"></a><!-- doxytag: member="tivx_reference_t::scope" ref="ac5f7c7cef208efccb8a400470d6b6611" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> <a class="el" href="structtivx__reference__t.html#ac5f7c7cef208efccb8a400470d6b6611">tivx_reference_t::scope</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The pointer to the object's scope parent. When virtual objects are scoped within a graph, this will point to that parent graph. This is left generic to allow future scoping variations. By default scope should be the same as context. </p>

</div>
</div>
<a class="anchor" id="a2f4a238aac75334b52e1b9a52a576194"></a><!-- doxytag: member="tivx_reference_t::name" ref="a2f4a238aac75334b52e1b9a52a576194" args="[VX_MAX_REFERENCE_NAME]" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">char <a class="el" href="structtivx__reference__t.html#a2f4a238aac75334b52e1b9a52a576194">tivx_reference_t::name</a>[VX_MAX_REFERENCE_NAME]</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reference name. </p>

</div>
</div>
<a class="anchor" id="a642d6c4ea88ea88f63fc426a4ab33fe2"></a><!-- doxytag: member="tivx_reference_t::external_count" ref="a642d6c4ea88ea88f63fc426a4ab33fe2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a1ddb983b9696cafdb4256c0df757171c">vx_uint32</a> <a class="el" href="structtivx__reference__t.html#a642d6c4ea88ea88f63fc426a4ab33fe2">tivx_reference_t::external_count</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The count of the number of users with this reference. When greater than 0, this can not be freed. When zero, the value can be considered inaccessible. </p>

</div>
</div>
<a class="anchor" id="a6f9a5f3dcba8c5228dca31493f98f742"></a><!-- doxytag: member="tivx_reference_t::internal_count" ref="a6f9a5f3dcba8c5228dca31493f98f742" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a1ddb983b9696cafdb4256c0df757171c">vx_uint32</a> <a class="el" href="structtivx__reference__t.html#a6f9a5f3dcba8c5228dca31493f98f742">tivx_reference_t::internal_count</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The count of the number of framework references. When greater than 0, this can not be freed. </p>

</div>
</div>
<a class="anchor" id="a8aa4044294f8eb1c30ce4d09afd1c4fa"></a><!-- doxytag: member="tivx_reference_t::mem_alloc_callback" ref="a8aa4044294f8eb1c30ce4d09afd1c4fa" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__group__vx__reference.html#ga8e985f6c4f883699f2b91dae32f95c8b">tivx_reference_callback_f</a> <a class="el" href="structtivx__reference__t.html#a8aa4044294f8eb1c30ce4d09afd1c4fa">tivx_reference_t::mem_alloc_callback</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Object specific function that is called to allcoate object memory. </p>

</div>
</div>
<a class="anchor" id="a9263b6aa76840e5254d766e9567af7dd"></a><!-- doxytag: member="tivx_reference_t::destructor_callback" ref="a9263b6aa76840e5254d766e9567af7dd" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__group__vx__reference.html#ga8e985f6c4f883699f2b91dae32f95c8b">tivx_reference_callback_f</a> <a class="el" href="structtivx__reference__t.html#a9263b6aa76840e5254d766e9567af7dd">tivx_reference_t::destructor_callback</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Object specific function that is called to destroy an object when refernce count reaches zero. </p>

</div>
</div>
<a class="anchor" id="a68918255893d2784a3aa9ac6ad638edf"></a><!-- doxytag: member="tivx_reference_t::release_callback" ref="a68918255893d2784a3aa9ac6ad638edf" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">tivx_reference_release_callback_f <a class="el" href="structtivx__reference__t.html#a68918255893d2784a3aa9ac6ad638edf">tivx_reference_t::release_callback</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Object specific function that is called to release an object. </p>

</div>
</div>
<a class="anchor" id="a743a14f09405c30f5f39e36bde0beaef"></a><!-- doxytag: member="tivx_reference_t::lock" ref="a743a14f09405c30f5f39e36bde0beaef" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__group__tivx__mutex.html#gaca8bf54b8519ecd4c6aa8368286bde45">tivx_mutex</a> <a class="el" href="structtivx__reference__t.html#a743a14f09405c30f5f39e36bde0beaef">tivx_reference_t::lock</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Lock to take for the reference. </p>

</div>
</div>
<a class="anchor" id="af655518f6f2a7e179d828e95c1a74ce8"></a><!-- doxytag: member="tivx_reference_t::delay" ref="af655518f6f2a7e179d828e95c1a74ce8" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a2c6de63476aff4a009bac8d0eb9800d1">vx_delay</a> <a class="el" href="structtivx__reference__t.html#af655518f6f2a7e179d828e95c1a74ce8">tivx_reference_t::delay</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a1caf1c5feb88111ebb5e38a4da188bd9"></a><!-- doxytag: member="tivx_reference_t::delay_slot_index" ref="a1caf1c5feb88111ebb5e38a4da188bd9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a822fc495cb9045d45893eed297d48737">vx_int32</a> <a class="el" href="structtivx__reference__t.html#a1caf1c5feb88111ebb5e38a4da188bd9">tivx_reference_t::delay_slot_index</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ae599ad74e0f2733829ae0e99c666a1fc"></a><!-- doxytag: member="tivx_reference_t::is_virtual" ref="ae599ad74e0f2733829ae0e99c666a1fc" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0">vx_bool</a> <a class="el" href="structtivx__reference__t.html#ae599ad74e0f2733829ae0e99c666a1fc">tivx_reference_t::is_virtual</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>This indicates if the object is virtual or not. </p>

</div>
</div>
<a class="anchor" id="afcce2c06f3667f29ef1688dbd8542f05"></a><!-- doxytag: member="tivx_reference_t::is_accessible" ref="afcce2c06f3667f29ef1688dbd8542f05" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0">vx_bool</a> <a class="el" href="structtivx__reference__t.html#afcce2c06f3667f29ef1688dbd8542f05">tivx_reference_t::is_accessible</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Can this reference be accessed by user application Used for virtual reference's only. </p>

</div>
</div>
<a class="anchor" id="a1f5d87219e4c59beee89ad61376ef464"></a><!-- doxytag: member="tivx_reference_t::obj_desc" ref="a1f5d87219e4c59beee89ad61376ef464" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structtivx__obj__desc__t.html">tivx_obj_desc_t</a>* <a class="el" href="structtivx__reference__t.html#a1f5d87219e4c59beee89ad61376ef464">tivx_reference_t::obj_desc</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>object descriptor </p>

</div>
</div>
</div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
